#include <sourcemod>
#include <console>
#include <clients>
#include <events>
#include <cstrike>
#include <sdktools>

#define MAX_CLASS_NUMBER 50
#define MAX_ITEM_NUMBER 100
#define MAX_NAME_LONG 30
#define MAX_DESCRIPTION_LONG 64
#define MAX_WEAPONS_ARRAY_SIZE 10
#define MAX_WEAPONS_NAME_LONG 64
#define MAX_STATS_DESCRIPTION_LONG 64
#define PLAYER_BASE_HP 100
#define DB_ERROR_BUFFER_SIZE 512

#define MOD_TAG "[Cmod]"

new	Handle:expKill,
	Handle:maxLvl,
	Handle:lvlRatio;

new Handle:sql;
new String:dbError[DB_ERROR_BUFFER_SIZE+1]

new	classNum,
	itemNum;

new	String:className[MAX_CLASS_NUMBER+1][MAX_NAME_LONG+1],
	String:classDescription[MAX_CLASS_NUMBER+1][MAX_DESCRIPTION_LONG+1];

new	minItemValue[MAX_ITEM_NUMBER+1],
	maxItemValue[MAX_ITEM_NUMBER+1];

new	Handle:classPlugin[MAX_CLASS_NUMBER+1] = INVALID_HANDLE,
	Handle:itemPlugin[MAX_ITEM_NUMBER+1] = INVALID_HANDLE;

new	classInt[MAX_CLASS_NUMBER+1],
	classCon[MAX_CLASS_NUMBER+1],
	classStr[MAX_CLASS_NUMBER+1],
	classDex[MAX_CLASS_NUMBER+1],
	String:classWeapons[MAX_CLASS_NUMBER+1][MAX_WEAPONS_ARRAY_SIZE+1][MAX_WEAPONS_NAME_LONG+1],
	classWeaponsNumber[MAX_CLASS_NUMBER+1];

new	bonusInt[MAXPLAYERS+1],
	bonusCon[MAXPLAYERS+1],
	bonusStr[MAXPLAYERS+1],
	bonusDex[MAXPLAYERS+1],
	bonusExp[MAXPLAYERS+1],
	String:bonusWeapons[MAXPLAYERS+1][MAX_WEAPONS_ARRAY_SIZE+1][MAX_WEAPONS_NAME_LONG+1],
	bonusWeaponsNumber[MAXPLAYERS+1];

new	String:itemName[MAX_ITEM_NUMBER+1][MAX_NAME_LONG+1],
	String:itemDescription[MAX_ITEM_NUMBER+1][MAX_DESCRIPTION_LONG+1];

new	playerClass[MAXPLAYERS+1],
	playerNewClass[MAXPLAYERS+1],
	playerLvl[MAXPLAYERS+1],
	playerExp[MAXPLAYERS+1],
	playerItem[MAXPLAYERS+1],
	playerItemValue[MAXPLAYERS+1],
	playerPoints[MAXPLAYERS+1],
	playerInt[MAXPLAYERS+1],
	playerCon[MAXPLAYERS+1],
	playerStr[MAXPLAYERS+1],
	playerDex[MAXPLAYERS+1],
	Float:playerSpeed[MAXPLAYERS+1];

	
new const	allowWeaponNumber = 3;	
new const	String:allowWeapon[][] = {
	"weapon_knife",
	"weapon_c4",
	"item_defuser"
};

public OnPluginStart()
{
	RegConsoleCmd("sm_klasa", cmdClassSelect);
	RegConsoleCmd("sm_class", cmdClassSelect);
	
	RegConsoleCmd("sm_klasy", cmdClassList);
	RegConsoleCmd("sm_classinfo", cmdClassList);
	
	RegConsoleCmd("sm_statystyki", cmdShowStats);
	RegConsoleCmd("sm_staty", cmdShowStats);
	RegConsoleCmd("sm_stats", cmdShowStats);
	
	RegConsoleCmd("sm_item", cmdShowItemDesc);
	RegConsoleCmd("sm_perk", cmdShowItemDesc);
	
	RegConsoleCmd("sm_drop", cmdDrop);
	RegConsoleCmd("sm_wyrzuc", cmdDrop);
	
	RegConsoleCmd("sm_reset", cmdReset);
	
	RegConsoleCmd("sm_useitem", cmdUseItem);
	RegConsoleCmd("sm_useskill", cmdUseSkill);

	HookEvent("player_death", eventPlayerDeath);
	HookEvent("player_spawn", eventPlayerSpawn);
	HookEvent("item_equip", eventItemEquip);
	
	expKill = CreateConVar("cmod_expkill", "10", "Kill exp");
	maxLvl = CreateConVar("cmod_maxlvl", "200", "Max lvl");
	lvlRatio = CreateConVar("cmod_lvlratio", "35", "exp for 1st lvl");
	
	AutoExecConfig(true, "cmod");
	
	strcopy(className[0], MAX_NAME_LONG, "Brak");
	strcopy(classDescription[0], MAX_DESCRIPTION_LONG, "Brak");
	strcopy(itemName[0], MAX_NAME_LONG, "Brak");
	strcopy(itemDescription[0], MAX_DESCRIPTION_LONG, "Brak");
	classWeaponsNumber[0] = 3;
	classWeapons[0][0] = "weapon_glock";
	classWeapons[0][1] = "weapon_hkp2000";
	classWeapons[0][2] = "weapon_knife";
	
	CreateTimer(0.1, showHUD, _, TIMER_REPEAT);
	//start (found in internet)
	if(GetUserMessageType() == UM_Protobuf)
	{
        HookUserMessage(GetUserMessageId("TextMsg"), TextMsg, true);
    }
    //stop
    
	sql = SQLite_UseDatabase("codmod_lvl", dbError, DB_ERROR_BUFFER_SIZE);
	if(sql == INVALID_HANDLE)
		PrintToServer("Could not connect: %s", dbError);
	
	SQL_FastQuery(sql, "CREATE VIRTUAL TABLE IF NOT EXISTS codmod_info USING fts4(steamid, class);");
		
	SQL_FastQuery(sql, "CREATE TABLE IF NOT EXISTS codmod (id INTEGER primary key autoincrement, steamid TEXT references codmod_info(steamid), class TEXT references codmod_info(class), lvl INTEGER, exp INTEGER, sPoints INTEGER, sInt INTEGER, sCon INTEGER, sStr INTEGER, sDex INTEGER, UNIQUE(steamid, class) ON CONFLICT REPLACE);");	
	
}

public OnClientDisconnect(id)
{
	if(IsClientInGame(id))
		saveToDB(id);
}

//start (found in internet)
public Action:TextMsg(UserMsg:msg_id, Handle:pb, players[], playersNum, bool:reliable, bool:init)
{
    if(!reliable || PbReadInt(pb, "msg_dst") != 3)
    {
        return Plugin_Continue;
    }

    new String:buffer[256];
    PbReadString(pb, "params", buffer, sizeof(buffer), 0);

    if(StrContains(buffer, "#Player_Cash_Award_") == 0 || StrContains(buffer, "#Team_Cash_Award_") == 0)
    {
        return Plugin_Handled;
    }

    return Plugin_Continue;
}
//stop

public OnClientConnected(id)
{
	playerClass[id] = 0;
	playerNewClass[id] = 0;
	playerLvl[id] = 1;
	playerExp[id] = 0;
	playerItem[id] = 0;
	playerPoints[id] = 0;
	playerInt[id] = 0;
	playerCon[id] = 0;
	playerStr[id] = 0;
	playerDex[id] = 0;
}



public classSelectHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select){
		decl String:info[32];
		GetMenuItem(menu, param2, info, sizeof(info));
		playerNewClass[param1] = param2 + 1;
		
		if(!playerClass[param1]){
			setNewClass(param1);
			return;	
		}
		PrintToChat(param1, "\x01\x0B\x01 \x07%s \x06Klasa zostanie zmieniona w następnej rundzie.", MOD_TAG);
	}else if (action == MenuAction_End){
		CloseHandle(menu);
	}
}

public classSelect(id)
{
	if(!classNum){
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Nie znaleziono żadnej klasy!", MOD_TAG, playerLvl[id]);
	}
	
	new String:name[MAX_NAME_LONG+32];
	new Handle:menu = CreateMenu(classSelectHandler);
	SetMenuTitle(menu, "Wybierz klase:");
	
	for(new i = 1; i <= classNum; i++){
		Format(name, sizeof(name), "%s (LVL: %d)", className[i], readLvlClassFromDB(id, i));
		AddMenuItem(menu, className[i], name);
	}

	DisplayMenu(menu, id, MENU_TIME_FOREVER);
}


public classDescHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_End){
		CloseHandle(menu);
	}
}

public classDesc(id, classID)
{
	if(!classNum){
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Nie znaleziono żadnej klasy!", MOD_TAG, playerLvl[id]);
	}
	
	new String:weapons[200] = "Bronie:\n";
	new String:stats[80];
	new String:name[MAX_NAME_LONG+9];
	new String:desc[MAX_DESCRIPTION_LONG+8];
	
	Format(name, sizeof(name), "Klasa:\n%s", className[classID]);
	Format(desc, sizeof(desc), "Opis: \n%s", classDescription[classID]);
	Format(stats, sizeof(stats), "Staty:\nINT: %d\nCON: %d\nSTR: %d\nDEX: %d", classInt[classID], classCon[classID], classStr[classID], classDex[classID]);
	
	for(new i; i < classWeaponsNumber[classID]; i++){
		StrCat(weapons, sizeof(weapons), classWeapons[classID][i]);
		StrCat(weapons, sizeof(weapons), "\n");
	}
		
	new Handle:menu = CreateMenu(classDescHandler) ;

	AddMenuItem(menu, "nazwa", name);
	AddMenuItem(menu, "opis", desc);
	AddMenuItem(menu, "int", stats);
	AddMenuItem(menu, "bronie", weapons);


	DisplayMenu(menu, id, MENU_TIME_FOREVER);
}

public classListHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select){
		classDesc(param1, param2 + 1);
		
	}else if (action == MenuAction_End){
		CloseHandle(menu);
	}
}

public classList(id)
{
	if(!classNum){
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Nie znaleziono żadnej klasy!", MOD_TAG, playerLvl[id]);
	}
	
	new Handle:menu = CreateMenu(classListHandler);
	SetMenuTitle(menu, "Wybierz klase:");
	
	for(new i = 1; i <= classNum; i++){
		AddMenuItem(menu, className[i], className[i]);
	}

	DisplayMenu(menu, id, MENU_TIME_FOREVER);
}

public Action:cmdClassList(id, args)
{
	classList(id);
	return Plugin_Handled;
}
//AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA <- THER I END \/
public nativeGetInt(Handle:plugin, numParams)
{
	return getInt(GetNativeCell(1), GetNativeCell(2), GetNativeCell(3), GetNativeCell(4));
}

public nativeGetCon(Handle:plugin, numParams)
{
	return getCon(GetNativeCell(1), GetNativeCell(2), GetNativeCell(3), GetNativeCell(4));
}

public nativeGetStr(Handle:plugin, numParams)
{
	return getStr(GetNativeCell(1), GetNativeCell(2), GetNativeCell(3), GetNativeCell(4));
}

public nativeGetDex(Handle:plugin, numParams)
{
	return getDex(GetNativeCell(1), GetNativeCell(2), GetNativeCell(3), GetNativeCell(4));
}

public nativeGetBonusExp(Handle:plugin, numParams)
{
	return bonusExp[GetNativeCell(1)]
}

public nativeGetCNameByCId(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(tmp <= classNum && tmp >= 0){
		SetNativeString(2, className[tmp], GetNativeCell(3));	
		return 1;	
	}else{
		return 0;
	}
}

public nativeGetCIdByCName(Handle:plugin, numParams)
{
	decl String:tmp[MAX_NAME_LONG+1];
	GetNativeString(1, tmp, sizeof(tmp));
	for(new i; i <= classNum; i++){
		if(StrEqual(tmp, className[i])){
			return i;
		}
	}
	return -1;
}

public nativeGetINameByIId(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(tmp <= itemNum && tmp >= 0){
		SetNativeString(2, itemName[tmp], GetNativeCell(3));
		return 1;
	}else{
		return 0;
	}
}

public nativeGetIIdByIName(Handle:plugin, numParams)
{
	decl String:tmp[MAX_NAME_LONG+1];
	GetNativeString(1, tmp, sizeof(tmp));
	for(new i; i <= itemNum; i++){
		if(StrEqual(tmp, itemName[i])){
			return i;
		}
	}
	return -1;
}

public nativeGetPlayerClass(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(IsValidClient(tmp)){
		return playerClass[tmp];
	}else{
		return -1;
	}
}

public nativeGetPlayerItem(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(IsValidClient(tmp)){
		return playerItem[tmp];
	}else{
		return -1;
	}
}

public nativeGetPlayerItemValue(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(IsValidClient(tmp)){
		return playerItemValue[tmp];
	}else{
		return 0;
	}
}

public nativeGetPlayerLvl(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(IsValidClient(tmp)){
		return playerLvl[tmp];
	}else{
		return 0;
	}
}

public nativeGetPlayerExp(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(IsValidClient(tmp)){
		return playerExp[tmp];
	}else{
		return 0;
	}
}

public nativeGetClassNum(Handle:plugin, numParams)
{
	return classNum;
}

public nativeGetItemNum(Handle:plugin, numParams)
{
	return itemNum;
}

public nativeSetPlayerItem(Handle:plugin, numParams)
{
	new id = GetNativeCell(1);
	if(IsValidClient(id))
		return 1;
	
	new tmp = GetNativeCell(2);
	if(!(tmp <= itemNum && tmp >= 0))
		return 2;
	
	removeItem(id);
	setPlayerItem(id, tmp);
	
	return 0;
}

public nativeSetBonusInt(Handle:plugin, numParams)
{
	bonusInt[GetNativeCell(1)] = GetNativeCell(2);
}

public nativeSetBonusCon(Handle:plugin, numParams)
{
	bonusCon[GetNativeCell(1)] = GetNativeCell(2);
}

public nativeSetBonusStr(Handle:plugin, numParams)
{
	bonusStr[GetNativeCell(1)] = GetNativeCell(2);
}

public nativeSetBonusDex(Handle:plugin, numParams)
{
	bonusDex[GetNativeCell(1)] = GetNativeCell(2);
}

public nativeSetBonusExp(Handle:plugin, numParams)
{
	bonusExp[GetNativeCell(1)] = GetNativeCell(2);
}

public nativeGiveExp(Handle:plugin, numParams)
{
	new tmp = GetNativeCell(1);
	if(!IsValidClient(tmp))
		return 0;
	playerExp[tmp] += GetNativeCell(2);
	checkLvl(tmp);
	return 1;
}

getInt(id, bool:pPlayer = true, bool:pBonus = true, bool:pClass = true)
{
	new point
	if(pPlayer)
		point += playerInt[id];
	if(pBonus)
		point += bonusInt[id];
	if(pClass)
		point += classInt[playerClass[id]];
	return point;
}

getCon(id, bool:pPlayer = true, bool:pBonus = true, bool:pClass = true)
{
	new poCon
	if(pPlayer)
		poCon += playerCon[id];
	if(pBonus)
		poCon += bonusCon[id];
	if(pClass)
		poCon += classCon[playerClass[id]];
	return poCon;
}

getStr(id, bool:pPlayer = true, bool:pBonus = true, bool:pClass = true)
{
	new poStr
	if(pPlayer)
		poStr += playerStr[id];
	if(pBonus)
		poStr += bonusStr[id];
	if(pClass)
		poStr += classStr[playerClass[id]];
	return poStr;
}

getDex(id, bool:pPlayer = true, bool:pBonus = true, bool:pClass = true)
{
	new poDex
	if(pPlayer)
		poDex += playerDex[id];
	if(pBonus)
		poDex += bonusDex[id];
	if(pClass)
		poDex += classDex[playerClass[id]];
	return poDex;
}

public statsHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select){
		
		if(!playerPoints[param1])
			return;
			
		switch(param2){
			case 0:{	
				if(playerInt[param1] < GetConVarInt(maxLvl)/2){
					playerInt[param1]++;
					playerPoints[param1]--;
				}else {
					PrintToChat(param1, "\x01\x0B\x01 \x07%s \x06Posiadasz maksymalny poziom \x03Inteligencji", MOD_TAG); 	
				}
			}
			case 1:{	
				if(playerCon[param1] < GetConVarInt(maxLvl)/2){
					playerCon[param1]++;
					playerPoints[param1]--;
				}else {
					PrintToChat(param1, "\x01\x0B\x01 \x07%s \x06Posiadasz maksymalny poziom \x03Zdrowia", MOD_TAG); 	
				}
			}
			case 2:{	
				if(playerStr[param1] < GetConVarInt(maxLvl)/2){
					playerStr[param1]++;
					playerPoints[param1]--;
				}else {
					PrintToChat(param1, "\x01\x0B\x01 \x07%s \x06Posiadasz maksymalny poziom \x03Siły", MOD_TAG); 	
				}
			}
			case 3:{	
				if(playerDex[param1] < GetConVarInt(maxLvl)){
					playerDex[param1]++;
					playerPoints[param1]--;
				}else {
					PrintToChat(param1, "\x01\x0B\x01 \x07%s \x06Posiadasz maksymalny poziom \x03Kondycji", MOD_TAG); 	
				}
			}									
		}
		
		if(playerPoints[param1] > 0)
			showStats(param1);
		
	}else if (action == MenuAction_End){
		CloseHandle(menu);
	}
}

public showStats(id)
{
	new Handle:menu = CreateMenu(statsHandler);
	
	decl	String:descInt[MAX_STATS_DESCRIPTION_LONG+1],
		String:descCon[MAX_STATS_DESCRIPTION_LONG+1],
		String:descStr[MAX_STATS_DESCRIPTION_LONG+1],
		String:descDex[MAX_STATS_DESCRIPTION_LONG+1],
		String:title[25];
	
	Format(title, sizeof(title), "Przydziel Punkty(%d):\n \n", playerPoints[id]);
	Format(descInt, sizeof(descInt), "Inteligencja(INT): %d \nZwieksza sile perkow i umiejetnosci klasy", getInt(id));
	Format(descCon, sizeof(descCon), "Zdrowie(CON): %d \nZwieksza ilość HP", getCon(id));
	Format(descStr, sizeof(descStr), "Siła(STR): %i \nZwiększa ARMOR", getStr(id));
	Format(descDex, sizeof(descDex), "Kondycja(DEX): %i \nZwieksza tempo chodu", getDex(id));	
	
	SetMenuTitle(menu, title);
	AddMenuItem(menu, "int", descInt);
	AddMenuItem(menu, "con", descCon);
	AddMenuItem(menu, "str", descStr);
	AddMenuItem(menu, "dex", descDex);
	DisplayMenu(menu, id, MENU_TIME_FOREVER);

}

public Action:cmdClassSelect(id, args)
{
	classSelect(id);
	return Plugin_Handled;
}

public Action:cmdShowStats(id, args)
{
	showStats(id);
	return Plugin_Handled;
}

public Action:cmdShowItemDesc(id, args)
{
	if(playerItem[id]){
		PrintToChat(id, "\x01\x0B\x01 \x06perk:\x03%s \x06opis: \x03%s", itemName[playerItem[id]], itemDescription[playerItem[id]]);
	}else{
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Nie posiadasz żadnego \x03itemu\x06, aby zdobyć item musisz kogoś zabić!", MOD_TAG); 
	} 
	return Plugin_Handled;
}

public Action:cmdDrop(id, args)
{
	if(playerItem[id]){
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Wyrzuciłeś \x03%s", MOD_TAG, itemName[playerItem[id]]); 	
		removeItem(id);
	}else{
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Nie posiadasz żadnego \x03itemu\x06, aby zdobyć item musisz kogoś zabić!", MOD_TAG); 
	}
	return Plugin_Handled;
}

public removeItem(id)
{
	new Function:func;
	func = GetFunctionByName(itemPlugin[playerItem[id]], "OnItemDisabled");
	if(func !=  INVALID_FUNCTION){
		Call_StartFunction(itemPlugin[playerItem[id]], func);
		Call_PushCell(id);
		Call_PushCell(playerItem[id]);
		Call_Finish();
	}
	playerItem[id] = 0;
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
   CreateNative("RegisterClass", registerClass);
   CreateNative("RegisterItem", registerItem);
   
   CreateNative("GetInt", nativeGetInt);
   CreateNative("GetCon", nativeGetCon);
   CreateNative("GetStr", nativeGetStr);
   CreateNative("GetDex", nativeGetDex);
   CreateNative("GetBonusExp", nativeGetBonusExp);
   CreateNative("GetCNameByCId", nativeGetCNameByCId);
   CreateNative("GetCIdByCName", nativeGetCIdByCName);
   CreateNative("GetPlayerClass", nativeGetPlayerClass);
   CreateNative("GetPlayerItem", nativeGetPlayerItem);
   CreateNative("GetPlayerItemValue", nativeGetPlayerItemValue);
   CreateNative("GetPlayerLvl", nativeGetPlayerLvl);
   CreateNative("GetPlayerExp", nativeGetPlayerExp);
   
   CreateNative("GetClassNum", nativeGetClassNum);
   CreateNative("GetItemNum", nativeGetItemNum);
   
   CreateNative("SetPlayerItem", nativeSetPlayerItem); 
   CreateNative("SetBonusInt", nativeSetBonusInt);
   CreateNative("SetBonusCon", nativeSetBonusCon);
   CreateNative("SetBonusStr", nativeSetBonusStr);
   CreateNative("SetBonusDex", nativeSetBonusDex);
   CreateNative("SetBonusExp", nativeSetBonusExp);
   
   CreateNative("GiveExp", nativeGiveExp);
   
   return APLRes_Success;
}

public eventPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if(!IsFakeClient(attacker) && (attacker != victim) && (playerClass[attacker] != 0)){
		new exp = GetConVarInt(expKill) + bonusExp[attacker];
		if(!IsFakeClient(victim)){
			if(playerLvl[victim] > playerLvl[attacker])
				exp += (playerLvl[victim]-playerLvl[attacker])*(GetConVarInt(expKill)/10);
		}else{
			exp = 1;
		}
		giveExp(attacker, exp);
		PrintToChat(attacker, "\x01\x0B\x01 \x07%s \x06Otrzymujesz \x03+%dxp \x06za zabójstwo", MOD_TAG, exp);
		if(!playerItem[attacker]){
			new random = GetRandomInt(1, itemNum);
			setPlayerItem(attacker, random);
		}
	}
}

public eventPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userID = GetClientOfUserId(GetEventInt(event, "userid"));
	CreateTimer(0.1, timerSpawn, userID, TIMER_FLAG_NO_MAPCHANGE);			
}

public eventItemEquip(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userID = GetClientOfUserId(GetEventInt(event, "userid"));
	new hClientWeapon = GetEntPropEnt(userID, Prop_Send, "m_hActiveWeapon");
	if(checkWeapon(userID))
		RemovePlayerItem(userID, hClientWeapon);
		//CS_DropWeapon(userID, hClientWeapon, false);
	SetEntPropFloat(userID, Prop_Send, "m_flLaggedMovementValue", playerSpeed[userID]);
}

checkWeapon(id)
{
	if(IsValidClient(id, true) && !IsFakeClient(id)){
		decl String:weapon[64];
		GetClientWeapon(id, weapon, sizeof(weapon));
		for(new i; i < classWeaponsNumber[playerClass[id]]; i++){
			//PrintToServer("id:%d    %d/%d %s %s", id, i, classWeaponsNumber[id], weapon, classWeapons[playerClass[id]][i]);
			if(StrEqual(weapon, classWeapons[playerClass[id]][i]))
				return 0;
		}
		
		for(new i; i < bonusWeaponsNumber[id]; i++){
			if(StrEqual(weapon, bonusWeapons[id][i]))
				return 0;
		}
		
		for(new i; i < allowWeaponNumber; i++){
			if(StrEqual(weapon, allowWeapon[i]))
				return 0;
		}
		return 1;
	}
	return 0;
		 
}
/*
public eventRoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userID = GetClientOfUserId(GetEventInt(event, "userid"));
	giveExp(userID, winExp + bonusExp[userID]);
	PrintToChat(userID, "\x01\x0B\x01 \x07%s \x06Otrzymujesz \x03+%dxp \x06za wygranie rundy", MOD_TAG, winExp + bonusExp[userID]);
}
*/
public Action:showHUD(Handle:timer) 
{ 
	for(new id = 1; id <= MaxClients; id++){
		if(IsValidClient(id, true)){
			PrintHintText(id, "[Klasa: %s]\n[LVL: %d][EXP %d/%d]\n[Item: %s]", className[playerClass[id]], playerLvl[id], playerExp[id], getExpForLvl(playerLvl[id]), itemName[playerItem[id]]); 
		}
	}
}  

stock bool:IsValidClient(client, bool:alive = false)
{
    if(client >= 1 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client) && (alive == false || IsPlayerAlive(client)))
    {
        return true;
    }
    
    return false;
} 

public giveExp(id, value)
{
	if(!IsValidClient(id))
		return 1;
	
	playerExp[id] += value;
	checkLvl(id);
	return 0;
}

setPlayerItem(id, itemID, bool:info = true)
{
	if(!itemNum)
		return;
	
	new Function:func;
	playerItem[id] = itemID;
	
	func = GetFunctionByName(itemPlugin[playerItem[id]], "OnItemEnabled");
	if(func !=  INVALID_FUNCTION){
		Call_StartFunction(itemPlugin[playerItem[id]], func);
		Call_PushCell(id);
		Call_PushCell(playerItem[id]);
		Call_Finish();
	}
	
	if(info)
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Znalazłeś \x03%s \x06", MOD_TAG, itemName[playerItem[id]]); 	
}

public Action:cmdReset(id, args)
{
	statsReset(id);
	PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Twoje statystyki zostały zrestartowane.", MOD_TAG); 
	return Plugin_Handled;	
}


public statsReset(id)
{
	playerPoints[id] = (playerLvl[id]-1)*2;
	playerInt[id] = 0;
	playerCon[id] = 0;
	playerStr[id] = 0;
	playerDex[id] = 0;
	
	if(playerPoints[id])
		showStats(id);
}

public checkLvl(id)
{
	new bool:lvlUp = false;
	new bool:lvlDown = false;
	
	if(!IsClientConnected(id))
		return;
	
	while(playerExp[id] >= getExpForLvl(playerLvl[id]) && playerLvl[id] < GetConVarInt(maxLvl)){
		playerLvl[id]++;
		playerPoints[id] = (playerLvl[id]-1)*2-playerInt[id]-playerCon[id]-playerStr[id]-playerDex[id];
		lvlUp = true;
	} 
	while(playerExp[id] < getExpForLvl(playerLvl[id]-1)){
		playerLvl[id]--;
		lvlDown = true;
	}
		
	if(playerLvl[id] > GetConVarInt(maxLvl)){
		playerLvl[id] = GetConVarInt(maxLvl);
		statsReset(id);
	}
	
	if(lvlDown){
		statsReset(id);
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Spadłeś na \x03%d \x06poziom!", MOD_TAG, playerLvl[id]);
	}else if(lvlUp){
		playerPoints[id] = (playerLvl[id]-1)*2-playerInt[id]-playerCon[id]-playerStr[id]-playerDex[id];
		showStats(id);
		PrintToChat(id, "\x01\x0B\x01 \x07%s \x06Awansowałeś na \x03%d \x06poziom!", MOD_TAG, playerLvl[id]);
	}
	
}

public getExpForLvl(lvl)
{
	return lvl*lvl*GetConVarInt(lvlRatio);
}

public Action:cmdUseItem(id, args)
{
	new Function:func;
	
	func = GetFunctionByName(itemPlugin[playerItem[id]], "OnPlayerUseItem");
	if(func !=  INVALID_FUNCTION){
		Call_StartFunction(itemPlugin[playerItem[id]], func);
		Call_PushCell(id);
		Call_PushCell(playerItem[id]);
		Call_Finish();
	}
	return Plugin_Handled;
}

public Action:cmdUseSkill(id, args)
{
	new Function:func;
	func = GetFunctionByName(classPlugin[playerClass[id]], "OnPlayerUseSkill");
	if(func !=  INVALID_FUNCTION){
		Call_StartFunction(classPlugin[playerClass[id]], func);
		Call_PushCell(id);
		Call_PushCell(playerClass[id]);
		Call_Finish();
	}
	return Plugin_Handled;
}

public registerClass(Handle:plugin, numParams)
{
	if(numParams != 7){
		ThrowNativeError(SP_ERROR_NATIVE, "Bad registerClass NumParams(%d)", numParams);
		return -1;
	}	
	if(++classNum > MAX_CLASS_NUMBER){
		ThrowNativeError(SP_ERROR_NATIVE, "classNum(%d) == MAX_CLASS_NUMBER(%d)", classNum, MAX_CLASS_NUMBER);
		return -2;	
	}
	
	classPlugin[classNum] = plugin;
	
	GetNativeString(1, className[classNum], MAX_NAME_LONG);
	GetNativeString(2, classDescription[classNum], MAX_DESCRIPTION_LONG);	
	
	classInt[classNum] = GetNativeCell(3);
	classCon[classNum] = GetNativeCell(4);
	classStr[classNum] = GetNativeCell(5);
	classDex[classNum] = GetNativeCell(6);
	
	new Handle:tmp = GetNativeCell(7);
	classWeaponsNumber[classNum] = GetArraySize(tmp);
	if(classWeaponsNumber[classNum] < MAX_WEAPONS_ARRAY_SIZE){
		for(new i; i < classWeaponsNumber[classNum]; i++)
			GetArrayString(tmp, i, classWeapons[classNum][i], MAX_WEAPONS_NAME_LONG);
	}else{
		for(new i; i < MAX_WEAPONS_ARRAY_SIZE; i++)
			GetArrayString(tmp, i, classWeapons[classNum][i], MAX_WEAPONS_NAME_LONG);
	}
	
	
	return classNum;
}

public registerItem(Handle:plugin, numParams)
{
	if(numParams != 4){
		ThrowNativeError(SP_ERROR_NATIVE, "Bad registerItem NumParams(%d)", numParams);
		return 1;
	}
		
	if(++itemNum > MAX_ITEM_NUMBER){
		ThrowNativeError(SP_ERROR_NATIVE, "itemNum(%d) == MAX_ITEM_NUMBER(%d)", itemNum, MAX_ITEM_NUMBER);
		return -1;
	}
			
	itemPlugin[itemNum] = plugin;
	GetNativeString(1, itemName[itemNum], MAX_NAME_LONG);
	GetNativeString(2, itemDescription[itemNum], MAX_DESCRIPTION_LONG);
	minItemValue[itemNum] = GetNativeCell(3);
	maxItemValue[itemNum] = GetNativeCell(4);
	
	return itemNum;
}

public setNewClass(id)
{	
	new result;
	new Function:func;
	
	func = GetFunctionByName(classPlugin[playerClass[id]], "OnClassDisabled");
	if(func !=  INVALID_FUNCTION){
		Call_StartFunction(classPlugin[playerClass[id]], func);
		Call_PushCell(id);
		Call_PushCell(playerClass[id]);
		Call_Finish(result);
	}

	func = GetFunctionByName(classPlugin[playerNewClass[id]], "OnClassEnabled");
	if(func !=  INVALID_FUNCTION){	
		Call_StartFunction(classPlugin[playerNewClass[id]], func);
		Call_PushCell(id);
		Call_PushCell(playerClass[id]);
		Call_Finish(result);
	}
	
	if(result == 4){
		playerClass[id] = 0;
		playerNewClass[id] = 0;
		classSelect(id);
		return 1;
	}
	
	saveToDB(id);
	playerClass[id] = playerNewClass[id];
	playerNewClass[id] = 0;
	readClassFromDB(id, playerClass[id]);
	
	if(IsValidClient(id, true) && !IsFakeClient(id)){
		removeWeapons(id);
		giveWeapons(id);
		activeStats(id);
	}
	return 0;
}



public removeWeapons(id)
{
	if(IsValidClient(id, true) && !IsFakeClient(id)){
		new slot = -1;
		
		slot = GetPlayerWeaponSlot(id, CS_SLOT_PRIMARY);
		if(slot != -1)
			RemovePlayerItem(id, slot);
			
		slot = GetPlayerWeaponSlot(id, CS_SLOT_SECONDARY);	
		if(slot != -1)	
			RemovePlayerItem(id, slot);
			
		slot = GetPlayerWeaponSlot(id, CS_SLOT_KNIFE);	
		if(slot != -1)	
			RemovePlayerItem(id, slot);
			
		slot = GetPlayerWeaponSlot(id, CS_SLOT_GRENADE);	
		if(slot != -1)	
			RemovePlayerItem(id, slot);
	}
}


public giveWeapons(id)
{
	if(IsValidClient(id, true) && !IsFakeClient(id)){
		for(new i; i < classWeaponsNumber[playerClass[id]]; i++){
			GivePlayerItem(id, classWeapons[playerClass[id]][i]);
		}
		for(new i; i < bonusWeaponsNumber[id]; i++)
			GivePlayerItem(id, bonusWeapons[id][i]);
	}
}

public Action:timerSpawn(Handle:timer, any:client)
{
	if(IsClientConnected(client) && IsClientInGame(client)){
		if(playerNewClass[client])
			setNewClass(client);
			
		if(!playerClass[client])
			classSelect(client);
		
		if(playerPoints[client])
			showStats(client);
		
		removeWeapons(client);	
		giveWeapons(client);
		activeStats(client);
	}
}

public readClassFromDB(id, classN)
{
	new String:tmp[513];
	decl String:authid[64];
	if(!GetClientAuthId(id, AuthId_Steam2, authid, 63))
		return -1;
		
	Format(tmp, sizeof(tmp), "SELECT lvl, exp, sPoints, sInt, sCon, sStr, sDex FROM codmod WHERE steamID = '%s' AND class = '%s';", authid, className[classN]);
	new Handle:query = SQL_Query(sql, tmp);
	
	if(query == INVALID_HANDLE){
		SQL_GetError(sql, dbError, sizeof(dbError))
		PrintToServer("Failed to readClassFromDB query (error: %s)", dbError)
		return 0;
	}
	
	if(SQL_GetRowCount(query)){
		playerLvl[id] = SQL_FetchInt(query, 0);
		playerExp[id] = SQL_FetchInt(query, 1);
		playerPoints[id] = SQL_FetchInt(query, 2);
		playerInt[id] = SQL_FetchInt(query, 3);
		playerCon[id] = SQL_FetchInt(query, 4);
		playerStr[id] = SQL_FetchInt(query, 5);
		playerDex[id] = SQL_FetchInt(query, 6);
	}else{
		playerLvl[id] = 1;
		playerExp[id] = 0;
		playerPoints[id] = 0;
		playerInt[id] = 0;
		playerCon[id] = 0;
		playerStr[id] = 0;
		playerDex[id] = 0;
	}
	
	CloseHandle(query)
	return 1;
}

public saveToDB(id)
{
	if(IsFakeClient(id))
		return -2;
	new String:tmp[1025];
	decl String:authid[64];
	if(!GetClientAuthId(id, AuthId_Steam2, authid, 63))
		return -1;
		
	Format(tmp, sizeof(tmp), "INSERT INTO codmod (steamid, class, lvl, exp, sPoints, sInt, sCon, sStr, sDex) VALUES ('%s', '%s', %d, %d, %d, %d, %d, %d, %d);", authid, className[playerClass[id]], playerLvl[id], playerExp[id], playerPoints[id], playerInt[id], playerCon[id], playerStr[id], playerDex[id]);
	if(!SQL_FastQuery(sql, tmp)){
		SQL_GetError(sql, dbError, sizeof(dbError))
		PrintToServer("Failed to INSERT query (error: %s)", dbError)
		return 1;
	}
	return 0;
}

public readLvlClassFromDB(id, classN)
{
	new String:tmp[513];
	decl String:authid[64];
	if(!GetClientAuthId(id, AuthId_Steam2, authid, 63))
		return -1;
	Format(tmp, sizeof(tmp), "SELECT lvl FROM codmod WHERE steamID = '%s' AND class = '%s';", authid, className[classN]);
	new Handle:query = SQL_Query(sql, tmp);
	
	if(query == INVALID_HANDLE){
		SQL_GetError(sql, dbError, sizeof(dbError))
		PrintToServer("Failed to query readLvlClassFromDB (error: %s)", dbError)
		return -2;
	}
	
	if(SQL_GetRowCount(query)){
		new r = SQL_FetchInt(query, 0);
		CloseHandle(query);
		return r;
	}else{
		CloseHandle(query);
		return 1;
	}
}

public activeStats(client)
{
	SetEntData(client, FindDataMapOffs(client, "m_iMaxHealth"), PLAYER_BASE_HP+getCon(client), 4, true);
	SetEntData(client, FindDataMapOffs(client, "m_iHealth"), PLAYER_BASE_HP+getCon(client), 4, true);
		
	playerSpeed[client] = 1.0 + (getDex(client)/100); 
    
	if(getStr(client)>=0)
		SetEntProp(client, Prop_Data, "m_ArmorValue", getStr(client), 4);
}

public Plugin:myinfo =
{
	name = "Cmod core",
	author = "PLX",
	description = "Easy RPG Mod",
	version = "0.1",
	url = "http://steamcommunity.com/id/plx211"
};

